//--------------------------------------------------------------------------
// Datablocks BlastCannon turret
//--------------------------------------

datablock SensorData(BlastCannonTurretSensor)
{
detects = true;
detectsUsingLOS = true;
detectsPassiveJammed = false;
detectsActiveJammed = false;
detectsCloaked = false;
detectionPings = true;
detectRadius = 60;
};

datablock ParticleData(BlastCannonSmokeParticle)
{
    dragCoefficient = 3;
    gravityCoefficient = 0.1;
    windCoefficient = 0;
    inheritedVelFactor = 0.282258;
    constantAcceleration = 0;
    lifetimeMS = 4838;
    lifetimeVarianceMS = 150;
    useInvAlpha = 0;
    spinRandomMin = 0;
    spinRandomMax = 0;
    textureName = "special/Explosion/Exp_0040.png";
    times[0] = 0;
    times[1] = 0.5;
    times[2] = 1;
    colors[0] = "1.000000 0.360000 0.260000 1.000000";
    colors[1] = "1.000000 0.424000 0.260000 0.000000";
    colors[2] = "1.000000 0.424000 0.260000 0.000000";
    sizes[0] = 2;
    sizes[1] = 0.5;
    sizes[2] = 2;
};

datablock ParticleEmitterData(BlastCannonSmokeEmitter)
{
    ejectionPeriodMS = 7;
    periodVarianceMS = 3;
    ejectionVelocity = 5;
    velocityVariance = 1;
    ejectionOffset =   0;
    thetaMin = 0;
    thetaMax = 60;
    phiReferenceVel = 0;
    phiVariance = 360;
    overrideAdvances = 0;
    orientParticles= 0;
    orientOnVelocity = 1;
    particles = "BlastCannonSmokeParticle";
};

datablock ExplosionData(BlastCannonExplosion)
{
   explosionShape = "effect_plasma_explosion.dts";
   playSpeed = 1.5;
   soundProfile   = MissileExplosionSound;
   faceViewer = true;

   sizes[0] = "10.5 10.5 10.5";
   sizes[1] = "10.5 10.5 10.5";
   sizes[2] = "10.5 10.5 10.5";

   shakeCamera = true;
   camShakeFreq = "6.0 7.0 7.0";
   camShakeAmp = "70.0 70.0 70.0";
   camShakeDuration = 1.0;
   camShakeRadius = 7.0;
};

datablock SeekerProjectileData(BlastCannonShot)
{
   casingShapeName     = "weapon_missile_casement.dts";
   projectileShapeName = "weapon_missile_projectile.dts";
   scale = "50 50 50";
   hasDamageRadius     = true;
   indirectDamage      = 0.8;
   damageRadius        = 8.0;
   radiusDamageType    = $DamageType::Missile;
   kickBackStrength    = 2000;

   explosion           = "BlastCannonExplosion";
   splash              = MissileSplash;
   velInheritFactor    = 1.0;    // to compensate for slow starting velocity, this value
                                 // is cranked up to full so the missile doesn't start
                                 // out behind the player when the player is moving
                                 // very quickly - bramage

   baseEmitter         = BlastCannonSmokeEmitter;
   delayEmitter        = BlastCannonSmokeEmitter;
   puffEmitter         = BlastCannonSmokeEmitter;
   bubbleEmitter       = BlastCannonSmokeEmitter;
   bubbleEmitTime      = 1.0;

   exhaustEmitter      = BlastCannonSmokeEmitter;
   exhaustTimeMs       = 300;
   exhaustNodeName     = "muzzlePoint1";

   lifetimeMS          = 6000;
   muzzleVelocity      = 10.0;
   maxVelocity         = 80.0;
   turningSpeed        = 110.0;
   acceleration        = 400.0;

   proximityRadius     = 3;

   terrainAvoidanceSpeed         = 180;
   terrainScanAhead              = 25;
   terrainHeightFail             = 12;
   terrainAvoidanceRadius        = 100;

   flareDistance = 200;
   flareAngle    = 30;

   sound = MissileProjectileSound;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.2 0.05 0";

   useFlechette = true;
   flechetteDelayMs = 550;
   casingDeb = FlechetteDebris;

   explodeOnWaterImpact = false;
};

datablock TurretData(BlastCannonTurretDeployed) : TurretDamageProfile
{
className = DeployedTurret;
shapeFile = "turret_outdoor_deploy.dts";
mass = 5.0;
maxDamage = 1.5; //was 0.5;
destroyedLevel = 0.5;
disabledLevel = 0.21;
explosion = SmallTurretExplosion;
expDmgRadius = 5.0;
expDamage = 0.25;
expImpulse = 500.0;
repairRate = 0;
heatSignature = 0.0;
deployedObject = true;
thetaMin = 5;
thetaMax = 145;
thetaNull = 90;
primaryAxis = zaxis;
isShielded = true;
energyPerDamagePoint = 30;
maxEnergy = 50;
rechargeRate = 0.20; //was 0.10;
barrel = DeployableBlastCannonTurretBarrel;
canControl = true;
cmdCategory = "DTactical";
cmdIcon = CMDTurretIcon;
cmdMiniIconName = "commander/MiniIcons/com_turret_grey";
targetNameTag = 'Blast Cannon';
targetTypeTag = 'Turret';
sensorData = BlastCannonTurretSensor;
sensorRadius = BlastCannonTurretSensor.detectRadius;
sensorColor = "191 0 226";
firstPersonOnly = true;
renderWhenDestroyed = true;
debrisShapeName = "debris_generic_small.dts";
debris = TurretDebrisSmall;
};

datablock TurretImageData(DeployableBlastCannonTurretBarrel)
{
shapeFile = "turret_muzzlepoint.dts";
item = BlastCannonTurretBarrel;
rotation = "0 1 0 90";
//rotation = "0 0 0 0";
offset = "0 0 0";
projectile = BlastCannonShot;
projectileType = SeekerProjectile;
usesEnergy = true;
fireEnergy = 10; ///was 20
minEnergy = 10; ///was 20
lightType = "WeaponFireLight";
lightColor = "0.25 0.15 0.15 1.0";
lightTime = "1000";
lightRadius = "2";
muzzleFlash = IndoorTurretMuzzleFlash;

// Turret parameters
activationMS = 150;
deactivateDelayMS = 300;
thinkTimeMS = 150;
degPerSecTheta = 580;
degPerSecPhi = 960;
attackRadius = 150; //100

// State Data
stateName[0] = "Preactivate";
stateTransitionOnLoaded[0] = "Activate";
stateTransitionOnNoAmmo[0] = "NoAmmo";

stateName[1] = "Activate";
stateTransitionOnTimeout[1] = "Ready";
stateTimeoutValue[1] = 0.05;
stateSequence[1] = "Activated";
stateSound[1] = DiscSwitchSound;

stateName[2] = "Ready";
stateTransitionOnNoAmmo[2] = "NoAmmo";
stateTransitionOnTriggerDown[2] = "Fire";
stateSequence[2] = "DiscSpin";
stateSound[2] = DiscLoopSound;

stateName[3] = "Fire";
stateTransitionOnTimeout[3] = "Reload";
stateTimeoutValue[3] = 0.025;
stateFire[3] = true;
stateRecoil[3] = LightRecoil;
stateAllowImageChange[3] = false;
stateSequence[3] = "Fire";
stateScript[3] = "onFire";
stateSound[3] = DiscFireSound;

stateName[4] = "Reload";
stateTransitionOnNoAmmo[4] = "NoAmmo";
stateTransitionOnTimeout[4] = "Ready";
stateTimeoutValue[4] = 0.1; // 0.25 load, 0.25 spinup
stateAllowImageChange[4] = false;
stateSequence[4] = "Reload";
stateSound[4] = DiscReloadSound;

stateName[5] = "NoAmmo";
stateTransitionOnAmmo[5] = "Reload";
stateSequence[5] = "NoAmmo";
stateTransitionOnTriggerDown[5] = "DryFire";

stateName[6] = "DryFire";
//stateSound[6] = DiscDryFireSound;
stateTimeoutValue[6] = 0.1;
stateTransitionOnTimeout[6] = "NoAmmo";

};
datablock ShapeBaseImageData(BlastCannonTurretDeployableImage)
{
mass = 15;
shapeFile = "pack_deploy_turreti.dts";
item = BlastCannonTurretDeployable;
mountPoint = 1;
offset = "0 0 0";
deployed = BlastCannonTurretDeployed;
stateName[0] = "Idle";
stateTransitionOnTriggerDown[0] = "Activate";

stateName[1] = "Activate";
stateScript[1] = "onActivate";
stateTransitionOnTriggerUp[1] = "Idle";

isLarge = true;
emap = true;
maxDepSlope = 360;
deploySound = TurretDeploySound;
minDeployDis = 0.5;
maxDeployDis = 5.0;
};

datablock ItemData(BlastCannonTurretDeployable)
{
className = Pack;
catagory = "Deployables";
shapeFile = "pack_deploy_turreti.dts";
mass = 3.0;
elasticity = 0.2;
friction = 0.6;
pickupRadius = 1;
rotate = false;
image = "BlastCannonTurretDeployableImage";
pickUpName = "a blast cannon turret pack";
emap = true;
};

datablock ShapeBaseImageData(BlastCannonImage2) {
   shapeFile = "TR2weapon_mortar.dts";
   offset = "0.0 0 0.4";
   rotation = "0 1 0 45";
};

datablock ShapeBaseImageData(BlastCannonImage3) {
   shapeFile = "TR2weapon_mortar.dts";
   offset = "0.17 0 -0.6";
   rotation = "0 1 0 135";
};

//--------------------------------------------------------------------------
// Functions
//--------------------------------------

function BlastCannonTurretDeployableImage::testNoTerrainFound(%item)
{
// created to prevent console errors
}

function BlastCannonTurretDeployableImage::testNoInteriorFound(%item)
{
// created to prevent console errors
}

function BlastCannonTurretDeployableImage::onDeploy(%item, %plyr, %slot)
{
%searchRange = 5.0;
%mask = $TypeMasks::TerrainObjectType | $TypeMasks::InteriorObjectType;
%eyeVec = %plyr.getEyeVector();
%eyeTrans = %plyr.getEyeTransform();
%eyePos = posFromTransform(%eyeTrans);
%nEyeVec = VectorNormalize(%eyeVec);
%scEyeVec = VectorScale(%nEyeVec, %searchRange);
%eyeEnd = VectorAdd(%eyePos, %scEyeVec);
//%searchResult = containerRayCast(%eyePos, %eyeEnd, %mask, 0);
//if(!%searchResult ) {
//messageClient(%plyr.client, 'MsgBeaconNoSurface', 'c2Cannot place turret. You are too far from surface.');
//return 0;
//}
%terrPt = %item.surfacept;
%terrNrm = %item.surfacenrm;
%intAngle = getTerrainAngle(%terrNrm);
%rotAxis = vectorNormalize(vectorCross(%terrNrm, "0 0 1"));
if ((getWord(%terrNrm, 2) == 1) || (getWord(%terrNrm, 2) == -1))
%rotAxis = vectorNormalize(vectorCross(%terrNrm, "0 1 0"));
%rotation = %rotAxis @ " " @ %intAngle;
%playerVector = vectorNormalize(-1 * getWord(%plyr.getEyeVector(),1) SPC getWord(%plyr.getEyeVector(),0) SPC "0");
%item.surfaceNrm2 = %playerVector;
%rot = fullRot(%item.surfaceNrm,%item.surfaceNrm2);
if($Host::ExpertMode == 0) {
   %plyr.unmountImage(%slot);
   %plyr.decInventory(%item.item, 1);
}

%deplObj = new Turret() {
dataBlock = %item.deployed;
position = VectorAdd(%terrPt, VectorScale(%terrNrm, 0.03));
rotation = %rot;
};
%deplObj.setTransform(%item.surfacePt SPC %rot);
%deplObj.setAutoFire(false);
//----------------------------------
//        $barrel = new StaticShape()
//		{
//		dataBlock = CBarrel;
//		};
//        $barrel.SetScale("15 15 15");
//        $barrel.SetRotation("1 0 0 90");
//%deplObj.mountObject($barrel,4);
%deplObj.mountImage(BlastCannonImage2,4);
%deplObj.mountImage(BlastCannonImage3,5);
//----------------------------------

addDSurface(%item.surface,%deplObj);
%deplObj.setRechargeRate(%deplObj.getDatablock().rechargeRate);
%deplObj.team = %plyr.client.team;
%deplObj.setOwner(%plyr);
%deplObj.setOwnerClient(%plyr.client);
if(%deplObj.getTarget() != -1)
setTargetSensorGroup(%deplObj.getTarget(), %plyr.client.team);

addToDeployGroup(%deplObj);
AIDeployObject(%plyr.client, %deplObj);
serverPlay3D(%item.deploySound, %deplObj.getTransform());
$TeamDeployedCount[%plyr.team, %item.item]++;
%deplObj.deploy();
%deplObj.playThread($AmbientThread, "ambient");
return %deplObj;
}

function BlastCannonTurretDeployable::onPickup(%this, %obj, %shape, %amount)
{
// created to prevent console errors
}

function DeployableBlastCannonTurretBarrel::onFire( %data, %obj, %slot ) {
	%energy = %obj.getEnergyLevel();
	%p = new (SeekerProjectile)() {
		dataBlock = BlastCannonShot;
		initialDirection = %obj.getMuzzleVector(%slot);
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		damageFactor = 1;
		sourceSlot = %slot;
	};
	%obj.lastProjectile = %p;
	MissionCleanup.add(%p);
	%obj.setEnergyLevel(%energy - %data.fireEnergy);
}

function BlastCannonTurretDeployed::onDestroyed(%this, %obj, %prevState) {
	if (%obj.isRemoved)
		return;
	if ($Host::InvincibleDeployables != 1 || %obj.damageFailedDecon) {
		%obj.isRemoved = true;
		$TeamDeployedCount[%obj.team, BlastCannonTurretDeployable]--;
		remDSurface(%obj);
		%obj.schedule(500, "delete");
	}
    //----------------------------------
    //%obj.unmountObject($barrel);
    //$barrel.delete();
    //$barrel = "";
    //schedule(0,0,"killit",$barrel);
    //echo("killed "@$barrel);
    if ($Host::InvincibleDeployables != 1)
    {
       %obj.unmountImage(4);
       %obj.unmountImage(5);
    }
    //----------------------------------
	Parent::onDestroyed(%this, %obj, %prevState);
}
