datablock ShapeBaseImageData(WaypointDepImage) {
	mass = 20;
	emap = true;
	shapeFile = "stackable4l.dts";
	item = WaypointDepPack;
	mountPoint = 1;
	offset = "0 -0.18 -0.5";
	deployed = WaypointDepImage;
	heatSignature = 0;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";

	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateTransitionOnTriggerUp[1] = "Idle";

	isLarge = true;
	maxDepSlope = 360;
	deploySound = ItemPickupSound;

	minDeployDis = 0.5;
	maxDeployDis = 50.0;
};

datablock ItemData(WaypointDepPack) {
	className = "WaypointPack";
	catagory = "Deployables";
	shapeFile = "stackable4l.dts";
	mass = 5.0;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 1;
	rotate = true;
	image = "WaypointDepImage";
	pickUpName = "a waypoint pack";
	heatSignature = 0;
	emap = true;
 };

function WaypointDepPack::onPickup(%this, %obj, %shape, %amount) {
	// created to prevent console errors
}

function WaypointDepImage::onDeploy(%item, %plyr, %slot) {

	%playerVector = vectorNormalize(-1 * getWord(%plyr.getEyeVector(),1) SPC getWord(%plyr.getEyeVector(),0) SPC "0");
	%item.surfaceNrm2 = %playerVector;
	%rot = fullRot(%item.surfaceNrm,%item.surfaceNrm2);

	//%deplObj = new StaticShape()
    //{
	//   dataBlock = "EmitterDep";
    //   scale = "0.5 0.5 0.1";
	//};
    if(%plyr.packset == 0)
    {
    %deplObj = new WayPoint()
    {
       position = %item.surfacePt;
       name = %plyr.client.nameBase@"\'s House";
       datablock = "WayPointMarker";
       team = %plyr.team;
    };
    MissionCleanup.add(%deplObj);
    %deplObj.schedule(10000, "delete");
    }
    else if(%plyr.packset == 1)
    {
    %deplObj = new WayPoint()
    {
       position = %item.surfacePt;
       name = %plyr.client.nameBase@"\'s Bar";
       datablock = "WayPointMarker";
       team = %plyr.team;
    };
    MissionCleanup.add(%deplObj);
    %deplObj.schedule(10000, "delete");
    }
    else if(%plyr.packset == 2)
    {
    %deplObj = new WayPoint()
    {
       position = %item.surfacePt;
       name = %plyr.client.nameBase@"\'s Base";
       datablock = "WayPointMarker";
       team = %plyr.team;
    };
    MissionCleanup.add(%deplObj);
    %deplObj.schedule(10000, "delete");
    }
    else if(%plyr.packset == 3)
    {
    %deplObj = new WayPoint()
    {
       position = %item.surfacePt;
       name = %plyr.client.nameBase@"\'s Vehicle Pad";
       datablock = "WayPointMarker";
       team = %plyr.team;
    };
    MissionCleanup.add(%deplObj);
    %deplObj.schedule(10000, "delete");
    }
    else if(%plyr.packset == 4)
    {
    %deplObj = new WayPoint()
    {
       position = %item.surfacePt;
       name = %plyr.client.nameBase@"\'s SA\/Admin House";
       datablock = "WayPointMarker";
       team = %plyr.team;
    };
    MissionCleanup.add(%deplObj);
    %deplObj.schedule(10000, "delete");
    }
    schedule(0,0,"MessageClient",%plyr.client,%plyr.client,"\c2Note: Waypoints only last for 10 seconds");

	// set orientation
	%deplObj.setTransform(%item.surfacePt SPC %rot);

	// set the recharge rate right away
	if (%deplObj.getDatablock().rechargeRate)
		%deplObj.setRechargeRate(%deplObj.getDatablock().rechargeRate);

	// set team, owner, and handle
	%deplObj.team = %plyr.client.Team;
	%deplObj.setOwner(%plyr);

	// place the deployable in the MissionCleanup/Deployables group (AI reasons)
	addToDeployGroup(%deplObj);

	//let the AI know as well...
	AIDeployObject(%plyr.client, %deplObj);

	// play the deploy sound
	serverPlay3D(%item.deploySound, %deplObj.getTransform());

	// increment the team count for this deployed object
	//$TeamDeployedCount[%plyr.team, %item.item]++;

	addDSurface(%item.surface,%deplObj);
	%deplObj.powerFreq = %plyr.powerFreq;
        checkPowerObject(%deplObj);
        if (!%plyr.client.isAdmin)
        {
           if($Host::ExpertMode == 0) {
              %plyr.unmountImage(%slot);
	          %plyr.decInventory(%item.item, 1);
           }
        }


	return %deplObj;
}

function WaypointDep::onDestroyed(%this,%obj,%prevState) {
    if (%obj.isRemoved)
		return;
    %obj.isRemoved = true;
    Parent::onDestroyed(%this,%obj,%prevState);
	$TeamDeployedCount[%obj.team, WaypointDepPack]--;
	remDSurface(%obj);
	%obj.schedule(500, "delete");
}

function WaypointDepImage::onMount(%data, %obj, %node) {
	%obj.hasWaypointPack = true;
	%obj.packSet = 0;
}

function WaypointDepImage::onUnmount(%data, %obj, %node) {
	%obj.hasWaypointPack = ""; // not needed anymore
	%obj.packSet = 0;
}
