//---------------------------------------------------------
// Deployable door, Code by Linker
// If you must modify, give credit. Version distributed to MineGoBoom.
// The functions in this file reguarding door sliding belongs to me and me only.
// The receiver of this file has no right to take the functions in part or in whole for other purposes
// Other than to make this pack functional. 
//---------------------------------------------------------

datablock EffectProfile(DoorCloseEffect)
{
   effectname = "weapons/missile_fire";
   minDistance = 0.5;
   maxDistance = 20.0;
};

datablock AudioProfile(DoorCloseSound)
{
   filename    = "fx/vehicles/tank_mortar_fire.wav";
   description = AudioDefault3d;
   preload = true;
   effect = DoorCloseEffect;
};


datablock StaticShapeData(DeployedDoor) : StaticShapeDamageProfile {
	className = "door";
	shapeFile = "Pmiscf.dts"; // b or dmiscf.dts, alternate

	maxDamage      = 2;
	destroyedLevel = 2;
	disabledLevel  = 1.5;

	isShielded = true;
	energyPerDamagePoint = 60;
	maxEnergy = 100;
	rechargeRate = 0.25;

	explosion    = HandGrenadeExplosion;
	expDmgRadius = 3.0;
	expDamage    = 0.1;
	expImpulse   = 200.0;

	dynamicType = $TypeMasks::StaticShapeObjectType;
	deployedObject = true;
	cmdCategory = "DSupport";
	cmdIcon = CMDSensorIcon;
	cmdMiniIconName = "commander/MiniIcons/com_deploymotionsensor";
	targetNameTag = 'Door';
	deployAmbientThread = true;
	debrisShapeName = "debris_generic_small.dts";
	debris = DeployableDebris;
	heatSignature = 0;
	needsPower = true;
};

datablock ShapeBaseImageData(DoorDeployableImage) {
	mass = 20;
	emap = true;
	shapeFile = "stackable1s.dts";
	item = DoorDeployable;
	mountPoint = 1;
	offset = "0 0 0";
	deployed = DeployedDoor;
	heatSignature = 0;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";

	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateTransitionOnTriggerUp[1] = "Idle";

	isLarge = false;
	maxDepSlope = 360;
	deploySound = ItemPickupSound;

	minDeployDis = 0;
	maxDeployDis = 50.0;
};

datablock ItemData(DoorDeployable) {
	className = Pack;
	catagory = "Deployables";
	shapeFile = "stackable1s.dts";
	mass = 5.0;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 1;
	rotate = true;
	image = "DoorDeployableImage";
	pickUpName = "a door pack made by Linker";
	heatSignature = 0;
	emap = true;
};

function DoorDeployableImage::testObjectTooClose(%item) {
	return "";
}

function DoorDeployableImage::testNoTerrainFound(%item) {
	// don't check this for non-Landspike turret deployables
}

function DoorDeployable::onPickup(%this, %obj, %shape, %amount) {
	// created to prevent console errors
}

function DoorDeployableImage::onDeploy(%item, %plyr, %slot) {
	//Object
	%className = "StaticShape";

	%grounded = 0;
	if (%item.surface.getClassName() $= TerrainBlock)
		%grounded = 1;

	%playerVector = vectorNormalize(-1 * getWord(%plyr.getEyeVector(),1) SPC getWord(%plyr.getEyeVector(),0) SPC "0");

	if (%item.surfaceinher == 0) {
		if (vAbs(floorVec(%item.surfaceNrm,100)) $= "0 0 1")
			%item.surfaceNrm2 = %playerVector;
		else
			%item.surfaceNrm2 = vectorNormalize(vectorCross(%item.surfaceNrm,"0 0 1"));
	}

	%item.surfaceNrm3 = vectorCross(%item.surfaceNrm,%item.surfaceNrm2);

	%rot = fullRot(%item.surfaceNrm,%item.surfaceNrm2);
	%scale = "0.5 8 400";
	%dataBlock = %item.deployed;
		%mCenter = "0 0 -0.5";
		%pad = pad(%item.surfacePt SPC %item.surfaceNrm SPC %item.surfaceNrm2,%scale,%mCenter);
		%scale = getWords(%pad,0,2);
		%item.surfacePt = getWords(%pad,3,5);
		%rot = getWords(%pad,6,9);
	

	if (!%scaleIsSet)
		%scale = vectorMultiply(%scale,1/4 SPC 1/3 SPC 2);

	%deplObj = new (%className)() {
		dataBlock = %dataBlock;
		scale = %scale;
	};

//////////////////////////Apply settings//////////////////////////////

	// [[Location]]:

	// exact:
	%deplObj.setTransform(%item.surfacePt SPC %rot);

	// misc info
	addDSurface(%item.surface,%deplObj);

	// [[Settings]]:

	%deplObj.grounded = %grounded;
	%deplObj.needsFit = 1;

	// [[Normal Stuff]]:

//	if(%deplObj.getDatablock().rechargeRate)
//		%deplObj.setRechargeRate(%deplObj.getDatablock().rechargeRate);

	// set team, owner, and handle
	%deplObj.team = %plyr.client.team;
	%deplObj.setOwner(%plyr);

	// set power frequency
	%deplObj.powerFreq = %plyr.powerFreq;

	// set the sensor group if it needs one
	if (%deplObj.getTarget() != -1)
		setTargetSensorGroup(%deplObj.getTarget(), %plyr.client.team);

	// place the deployable in the MissionCleanup/Deployables group (AI reasons)
	addToDeployGroup(%deplObj);

	//let the AI know as well...
	AIDeployObject(%plyr.client, %deplObj);

	// play the deploy sound
	serverPlay3D(%item.deploySound, %deplObj.getTransform());

	// increment the team count for this deployed object
	$TeamDeployedCount[%plyr.team, %item.item]++;

	%deplObj.deploy();

	// Power object
	checkPowerObject(%deplObj);
	%deplobj.shxjyvuihaj=%deplobj.dsurface.getedge("0 0 0");

	%deplobj.timeout=getWord($expertSetting["Door",%plyr.expertSet],0);
	%deplobj.initialtransform=%deplobj.gettransform();
	%deplobj.nkjvhweoae=0;

	if (%plyr.packset==1)
		%deplobj.toggletype=1;

	if (%plyr.packset==2) {
		%deplobj.toggletype=0;
		%deplobj.powercontrol=1;
	}

	if (%plyr.packset==3) {
		%deplobj.toggletype=1;	
		%deplobj.powercontrol=1;
	}
			
	if (%plyr.packset==0)
		%deplobj.toggletype=0;

	if (%pad)
		deployEffect(%deplObj,%item.surfacePt,%item.surfaceNrm,"pad");
	return %deplObj;
}

function deployeddoor::onDestroyed(%this, %obj, %prevState) {
	if (%obj.isRemoved)
		return;
	%obj.isRemoved = true;
	Parent::onDestroyed(%this, %obj, %prevState);
	$TeamDeployedCount[%obj.team, DoorDeployable]--;
	remDSurface(%obj);
	%obj.schedule(500, "delete");
	cascade(%obj);
	fireBallExplode(%obj,1);
}

function DoorDeployableImage::onMount(%data, %obj, %node) {
	%obj.hasDoor = true; // set for blastcheck
	%obj.packSet = 0;
	%obj.expertSet = 3;
	displayPowerFreq(%obj);
}

function DoorDeployableImage::onUnmount(%data, %obj, %node) {
	%obj.hasDoor = "";
	%obj.packSet = 0;
	%obj.expertSet = 0;
}


function slidedoor(%door) {
	if (%door.xzkhvuwfasd==1)
		return;
	if (%door.shxjyvuihaj $= "")
		return;
	if (%door.shxjyvuihaj !$= "") {
		%uoivjkxbkwe=%door.shxjyvuihaj;
		%vec2=%door.getedge("0 0 0");
		%pointvec=vectornormalize(vectorsub(%uoivjkxbkwe,%vec2));
		%peujfsldfn=vectorscale(%pointvec,0.1);
		if (%door.nkjvhweoae == 0)
			%door.inittransform=%door.gettransform();
		iweqohbfsdmn(%door,%peujfsldfn,%uoivjkxbkwe);
		%door.xzkhvuwfasd=1;
		return;
	}
}
	
function slidedown(%door) {
	%vec2=%door.getedge("0 0 0");
	%height=getterrainheight(%vec2);
	%uoivjkxbkwe=setword(%vec2,2,%height);
	%pointvec=vectornormalize(vectorsub(%uoivjkxbkwe,%vec2));
	%peujfsldfn=vectorscale(%pointvec,0.1);
	%door.inittransform=%door.gettransform();
	if (%door.nkjvhweoae == 1) {
		%xucyvhkjwnbef=vectorscale(%amount,-1);
		schedule(0,0,"iowhefasmb",%door,%xucyvhkjwnbef,%target);
		return;
	}
	iweqohbfsdmn(%door,%peujfsldfn,%uoivjkxbkwe);
	%door.xzkhvuwfasd=1;
}

function iweqohbfsdmn(%door,%amount,%target) {
	%uoivjkxbkwe=%door.getposition();
	%uixycvjkbef=vectordist(%amount,"0 0 0");
	%poqitbxvv=vectordist(%uoivjkxbkwe,%target)/%uixycvjkbef;
	%poqitbxvv=%poqitbxvv * 2;
	%poqitbxvv=%poqitbxvv - 1;
	for (%i=0;%i<%poqitbxvv;%i++) {
		schedule(%i*20,0,"iuhjkbxc",%door,%amount);
		%olskhfbgsa=%i*20;
	}
	%timeout = %door.timeout * 1000;
	if (%timeout == 0) 
		%timeout=20;
	%oshagjsags=%olskhfbgsa + %timeout;
	%xucyvhkjwnbef=vectorscale(%amount,-1);
	if (%door.toggletype != 1) {
		schedule(%oshagjsags,0,"iowhefasmb",%door,%xucyvhkjwnbef,%target);
		return;
	}
	if (%door.toggletype == 1) {
		%oshagjsags=%olskhfbgsa;
		schedule(%oshagjsags,0,"dsjvzxuher",%door);
		return;
	}

}	

function iowhefasmb(%door,%amount,%target) {
	%door.xzkhvuwfasd=1;
	%uoivjkxbkwe=%door.getposition();
	%uixycvjkbef=vectordist(%amount,"0 0 0");
	%poqitbxvv=vectordist(%uoivjkxbkwe,%target)/%uixycvjkbef;
	%poqitbxvv=%poqitbxvv * 2;
	%poqitbxvv=%poqitbxvv - 1;
	for (%i=0;%i<%poqitbxvv;%i++) {
		schedule(%i*20,0,"iuhjkbxc",%door,%amount);
		%olskhfbgsa=%i*20;
	}
	%oshagjsags=%olskhfbgsa+20;
	schedule(%oshagjsags,0,"wegfsamnga",%door);
}
	
function iuhjkbxc(%door,%amount) {
		if (!isobject(%door))
			return;
	%ihefnmdfssfd=vectoradd(%door.getposition(),%amount);
	%rot=%door.getrotation();
	%door.settransform(%ihefnmdfssfd SPC %rot);
	%iwhppasgkj=ContainerRayCast(%door.getedge("1 1 1"), %door.getedge("-1 -1 -1"), $typemasks::Playerobjecttype | $typemasks::vehicleobjecttype, %door);
	if (isplayer(%iwhppasgkj)) {
		woihfsagnmsg(%iwhppasgkj);
		}
}

function wegfsamnga(%door) {
	%door.settransform(%door.initialtransform);
	%door.xzkhvuwfasd=0;
	%door.nkjvhweoae = 0;
	Serverplay3D(DoorCloseSound,%door.getposition());
}

function dsjvzxuher(%door) {
	%door.xzkhvuwfasd=0;
	if (%door.nkjvhweoae != 0) {
		%door.settransform(%door.inittransform);
		%door.nkjvhweoae=0;
		Serverplay3D(DoorCloseSound,%door.getposition());
		return;
	}
	%door.nkjvhweoae=1;
}

function woihfsagnmsg(%iwhppasgkj) {
	%iwhppasgkj.scriptkill();
	messageall(1,'%1 was caught in a sliding door.', %iwhppasgkj.client.name);
}
